'  Control Object

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  ' DAC Pins
  DAC_DATA_PIN  = 4
  DAC_A0_PIN    = 5
  DAC_A1_PIN    = 6
  DAC_CLR_PIN   = 7
  
OBJ
  DAC        : "DAC714 Object"
    
VAR
  long stack[40]  
  byte cog

PUB Initialize
  cog := 0
  DAC.Init(DAC_DATA_PIN, DAC_A0_PIN, DAC_A1_PIN, DAC_CLR_PIN)

PUB SetOutputLevel(level)
  if not cog
    DAC.SetOutputLevel(level)
  
PUB StartCycling
  StopCycling
  cog := cognew(CycleOutput, @stack) + 1
  return cog

PUB CycleOutput   
  repeat
    DAC.SetOutputLevel(3000)
    waitcnt(clkfreq / 2 + cnt)
    DAC.SetOutputLevel(30000)
    waitcnt(clkfreq / 2 + cnt)           

PUB StopCycling
  if cog
    cogstop(cog~ - 1)
    