CON
_clkmode = xtal1 + pll16x
_xinfreq = 5_000_000
  
OBJ
                                                        ' 1 cog (this object)
  STR_ENGINE      : "ASCII0_STREngine.spin"             ' 0 cog  
  PST             : "Parallax Serial Terminal"          ' 1 cog            
  CONTROL         : "Control Object"                    ' 1 cog

VAR
  long   stack[50]
  byte   cog
  
PUB Main

  PST.Start(115200)

  repeat
    result := Pst.RxCount
    PST.Str(string(11, 13, "Press any key to begin."))
    waitcnt(clkfreq / 2 + cnt)
  until result
  PST.RxFlush
  
  CONTROL.Initialize

  PST.Str(string(11, 13, "Setting constant output level for 3 seconds."))  
  CONTROL.SetOutputLevel(28000)

  repeat 3
    waitcnt(clkfreq + cnt)

  PST.Str(string(11, 13, "Cycling output level for 3 seconds."))        
  'CONTROL.StartCycling
  cog := cognew(CONTROL.CycleOutput, @stack)
  
  repeat 3
    waitcnt(clkfreq + cnt)

  PST.Str(string(11, 13, "Test complete."))
  'CONTROL.StopCycling
  cogstop(cog)



{{

CASE 1:
Calling CONTROL.StartCycling & CONTROL.StopCycling
Yeilds the following output ...
  Press any key to begin.
  Setting constant output level for 3 seconds.
  Cycling output level for 3 seconds.
  Test complete.

However, the DAC is set to constant level for 3 seconds.
But the DAC level does not change during the 3 second cycling period.



CASE 2:
Calling cognew(CONTROL.CycleOutput, @stack) & cogstop(cog)
Yeilds the following output ...

  Press any key to begin.
  Setting constant output level for 3 seconds.
  Cycling output level for 3 seconds.

The DAC is set to a constant level for 3 seconds.
Next, the DAC starts cycling every half second.
However, the DAC never stops cycling and the "Test Complete" message is not displayed.
  
}}  